package game.jam.at;

import com.badlogic.gdx.ApplicationListener;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Screen;
import com.badlogic.gdx.audio.Music;
import com.badlogic.gdx.audio.Sound;
import com.badlogic.gdx.controllers.Controllers;
import com.badlogic.gdx.graphics.GL10;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.Texture.TextureFilter;
import com.badlogic.gdx.graphics.g2d.Sprite;
import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.math.Vector2;
import com.badlogic.gdx.physics.box2d.Body;
import com.badlogic.gdx.physics.box2d.BodyDef;
import com.badlogic.gdx.physics.box2d.BodyDef.BodyType;
import com.badlogic.gdx.physics.box2d.Box2DDebugRenderer;
import com.badlogic.gdx.physics.box2d.CircleShape;
import com.badlogic.gdx.physics.box2d.FixtureDef;
import com.badlogic.gdx.physics.box2d.PolygonShape;
import com.badlogic.gdx.physics.box2d.World;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.Stage;

public class IntroScreen implements Screen {
	private OrthographicCamera camera;
	private SpriteBatch batch;
	private Sprite sprite;
    
    private Texture firstShot;
	private Texture secondShot;
	private Texture thirdShot;
	
	private Music crash;
	private Music funeral;
	private Music ghostappear;
	
	private MyGame game;
	
	float spriteX;
	
	int screenID;
	/**
	 * the renderer
	 */
	protected Box2DDebugRenderer renderer;
	
	public IntroScreen(MyGame Game) {
		game = Game;
	}

	public void create() {  
    	
    	spriteX = -390.0f;
    	screenID = 0;
    	
    	Texture.setEnforcePotImages(false);
    	// create the camera and the SpriteBatch
        camera = new OrthographicCamera();
        camera.setToOrtho(false, 800, 600);
        batch = new SpriteBatch();
        
		// create the debug renderer
		renderer = new Box2DDebugRenderer();
    	
		drawTexture("../Assets/v1/firstShot.png", "../Assets/sounds/panel1_crash.wav");
//		"../Assets/sounds/panel1_crash.wav"
//		"../Assets/v1/firstShot.png"
    }
    
    public void drawTexture(String picPath, String soundPath) {
    	crash = Gdx.audio.newMusic(Gdx.files.internal(soundPath));
		crash.setLooping(false);
		crash.play();

    	firstShot = new Texture(Gdx.files.internal(picPath));
		TextureRegion region = new TextureRegion(firstShot, 0, 0, 597, 600);
		
		sprite = new Sprite(region);
		sprite.setSize(camera.viewportHeight, camera.viewportWidth);
		sprite.setOrigin(0, 0);
		sprite.setPosition(spriteX, -camera.viewportHeight/2);
//		sprite.setRotation(-25);
		screenID++;
    }

    @Override
    public void dispose() {
    
    }

    @Override
    public void render(float f) {    
		Gdx.gl.glClearColor(0, 0, 0, 1);
		Gdx.gl.glClear(GL10.GL_COLOR_BUFFER_BIT);

		batch.setProjectionMatrix(camera.projection);
		
		spriteX += Gdx.graphics.getDeltaTime() * 5.0f;
		
		batch.begin();
		batch.draw(sprite, spriteX, sprite.getY());
		batch.end();
			
		switch (screenID) {
			case 1: {
				if (! crash.isPlaying()) {
					System.out.println("has stopped");
					drawTexture("../Assets/v1/secondShot.png", "../Assets/sounds/panel2_funeral.wav");
				}
			}
			break;
			
			case 2: {
				if (! crash.isPlaying()) {
					System.out.println("has stopped");
					drawTexture("../Assets/v1/thirdShot.png", "../Assets/sounds/panel3_ghostappear.wav");
				}
			}
			break;
			
			case 3: 
				if (! crash.isPlaying()) {
					System.out.println("has stopped");
					game.setGame();
				}
			break;
			
			default: 
				break;
		}
		
		
		
//		sprite.draw(batch);
//		for(GameObject gameObject : gameObjects){
//			batch.draw(gameObject.getSprite(), gameObject.getSprite().getX(), gameObject.getSprite().getY());
//		}
		
		
		
		
//		sprite.setX(2 * Gdx.graphics.getDeltaTime());

//		renderer.render(world, camera.combined);

		// set fps
//		world.step(1 / 60f, 6, 2);
    }

    @Override
    public void resize(int width, int height) {
    }

    @Override
    public void pause() {
    }

    @Override
    public void resume() {
    }

	@Override
	public void show() {
		create();
	}

	@Override
	public void hide() {
		// TODO Auto-generated method stub
		
	}
}